#ifndef IMAGE_FILTER_H
#define IMAGE_FILTER_H

#include <QtGui>

class ImageFilter : public QObject {
    Q_OBJECT

public:
    ImageFilter() { }
    virtual ~ImageFilter() { }

public:
    QImage process(QImage image) {
        QDialog* dialog = getDialog();
        if(dialog != 0) {
            int result = dialog->exec();
            if(result == QDialog::Accepted) {
                return (apply(image));
            } else {
                return image;
            }
        } else {
            return (apply(image));
        }
    }

protected:
    virtual QImage apply(QImage image) = 0;
    virtual QDialog* getDialog() = 0;
};

#endif // IMAGE_FILTER_H
